<?

class Layout {

	var $LAYOUT_ROOT = "";

	var $LAYOUT_CLASSIC = "";

	var $LAYOUT_PATH_LIST = array();	//Layoutų ϸ Key ´.

	var $LAYOUT_WIN32 = false;	//true̸ 迭(\), false̸ 迭(/) Path ̷.
								// c:\apache\htdocs
								// /home/ddoong/public_html
	
	var $LAYOUT_DEFS_FILE = "/public_include/layout_defs.inc.php";	//   ش.
																	//var $LAYOUT_DEFINITION_FILES = ""; 

	var $LAYOUT_DEFS = array();

	var $LAYOUT_REGISTER_GLOBALS = "on";	//offϰ $HTTP_GET_VARS[] ó Ѵ.
											//onϰ $ ó Ѵ.
	
	var $LAYOUT_ERROR_MESSAGE = ""; //  Ҷ layoutExecute Ǳ  ޼  HTML   ʵ ش.
	var $LAYOUT_ERROR_URL = ""; //LAYOUT_ERROR_MESSAGE ޼  ̵  Ѵ.

	//ش Ʈ θ ϸ Layoutü Ѵ.
	function Layout($root="", $win32=false) {

		global $HTTP_GET_VARS, $HTTP_POST_VARS, $HTTP_POST_FILES;
		global $HTTP_SESSION_VARS, $HTTP_COOKIE_VARS, $HTTP_SERVER_VARS, $HTTP_REFERER;


		@include $HTTP_SERVER_VARS[DOCUMENT_ROOT]."/public_include/config.inc.php";

		if($root == "") {
			$this->setLayoutRoot($HTTP_SERVER_VARS[DOCUMENT_ROOT]);
		} else {
			$this->setLayoutRoot($root);
		}

		$this->setLayoutOsType($boolean);

		if($this->LAYOUT_DEFS_FILE != "") {
			$this->setLyaoutDefsFile();
		}

	}


	//ش Ʈ θ Ѵ.
	function setLayoutRoot($root) {

		$this->LAYOUT_ROOT = $root;

	}


	//ش Ʈ θ Ѵ.
	function setLayoutOsType($boolean) {

		$this->LAYOUT_WIN32 = $boolean;

	}


	//Layout   Ѵ.
	function layoutDefine($classicLayout) {

		$this->LAYOUT_CLASSIC = $classicLayout;

	}


	//Layout ϴ  Tile Ѵ.
	function layoutPut($tilesKey, $tilesPath, $overwrite=true) {

		if($this->LAYOUT_WIN32 == true) {
			$tilesPath = $this->layoutPathConversion($tilesPath);
		}

		if($overwrite == true) {
			$this->LAYOUT_PATH_LIST[$tilesKey] = null;
		}

		$this->LAYOUT_PATH_LIST[$tilesKey][] = $tilesPath;

	}


	//Layout   Ѵ.
	function layoutExecute() {

		global $HTTP_GET_VARS, $HTTP_POST_VARS, $HTTP_POST_FILES;
		global $HTTP_SESSION_VARS, $HTTP_COOKIE_VARS, $HTTP_SERVER_VARS, $HTTP_REFERER;

		if(is_file($this->LAYOUT_ROOT.$this->LAYOUT_CLASSIC)) {

			// ޼     ۿ صд.
			ob_start();
			include $this->LAYOUT_ROOT.$this->LAYOUT_CLASSIC;
			$contents = ob_get_contents();
			
			if($this->LAYOUT_ERROR_MESSAGE != "") {
				// ޼  ³ ϰ ޼ .
				ob_end_clean();
				ob_end_flush();
				if($this->LAYOUT_ERROR_URL != "") {
					$this->messageMove($this->LAYOUT_ERROR_MESSAGE, $this->LAYOUT_ERROR_URL);
				} else {
					$this->errmsg($this->LAYOUT_ERROR_MESSAGE);
				}
			} else {
				// Ѵ.
				ob_end_flush();
				ob_end_clean();
			}


		} else {
			echo"ClassicLayout   ʾ  մϴ!!";
			exit;
		}

	}


	//Layout Ǿ ִ Tile  ִ´.
	function layoutInsert($tilesKey) {

		global $HTTP_GET_VARS, $HTTP_POST_VARS, $HTTP_POST_FILES;
		global $HTTP_SESSION_VARS, $HTTP_COOKIE_VARS, $HTTP_SERVER_VARS, $HTTP_REFERER;

		if(is_array($this->LAYOUT_PATH_LIST[$tilesKey])) {

			while(list($key, $val) = each($this->LAYOUT_PATH_LIST[$tilesKey])) {


				if(is_file($this->LAYOUT_ROOT.$val)) {
					include $this->LAYOUT_ROOT.$val;
				}

			}

		}

	}


	// 迭 θ ÷ ϱ⶧ layoutPutԼ   뿡 ˸° ȯѴ.
	function layoutPathConversion($tilesPath) {

		$tilesPath = ereg_replace("/", "\\", $tilesPath);
		return $tilesPath;

	}


	//layoutPut  String  ö Ѵ.
	function getLayoutAsString($tilesKey) {

		echo $this->LAYOUT_PATH_LIST[$tilesKey][0];

	}

	
	//$this->LAYOUT_DEFS_FILE ϱ  ̾ƿ  includeѴ.
	function setLyaoutDefsFile() {

		if($LAYOUT_WIN32 == true) {
			$defs_file = $this->layoutPathConversion($this->LAYOUT_DEFS_FILE);
		} else {
			$defs_file = $this->LAYOUT_DEFS_FILE;
		}
		include $this->LAYOUT_ROOT.$defs_file;

	}


	//$this->LAYOUT_DEFS_FILE  ̾ƿ Ѵ.
	function layoutUseDefinition($defs) {

		$this->layoutDefine($this->LAYOUT_DEFS[$defs]["classicLayout"]);
		if(is_array($this->LAYOUT_DEFS[$defs]["put"])) {
			while(list($key, $val) = each($this->LAYOUT_DEFS[$defs]["put"])) {
				$this->layoutPut($key, $val, true);
			}
		}

	}


}

?>