<?

//DDOONG.NETҽ ° ణ  κ   Ŭ ϱȣ ҽ ϰ ֽϴ.

class Smtp {

    var $host;
    var $fp;
    var $self;
    var $lastmsg;
    var $parts;
    var $error;
    var $debug;
    var $charset;
    var $ctype;


    function Smtp($host="localhost", $debug=false) {
        if($host == "self") $this->self = true;
        else $this->host = $host;
        $this->parts = array();
        $this->error = array();
        $this->charset = "euc-kr";
        $this->ctype = "text/html";
				
				$this->debug($debug); 
				$this->smtp_connect($host);
    }

    //   : 1
    function debug($debug=false) {
        $this->debug = $debug;
    }

    // smtp  Ѵ.
    function dialogue($code, $cmd) {

        fputs($this->fp, $cmd."\r\n");
        $line = fgets($this->fp, 1024);
        ereg("^([0-9]+).(.*)$", $line, &$data);
        $this->lastmsg = $data[0];

        if($this->debug) {
            echo htmlspecialchars($cmd)."<br>".$this->lastmsg."<br>";
            flush();
        }

        if($data[1] != $code) return false;
        return true;

    }

    //  smptp   Ѵ.
    function smtp_connect($host="localhost") {

        if($this->debug) {
            echo "SMTP($host) Connecting...<br>";
            flush();
        }

        if(!$host) $host = $this->host;
        if(!$this->fp = fsockopen($host, 25, $errno, $errstr, 10)) {
            $this->lastmsg = "SMTP($host) ӿ ߽ϴ.[$errno:$errstr]";
            return false;
        }

        $line = fgets($this->fp, 1024);
        ereg("^([0-9]+).(.*)$", $line, &$data);
        $this->lastmsg = $data[0];
        if($data[1] != "220") return false;

        if($this->debug) {
            echo $this->lastmsg."<br>";
            flush();
        }

        $this->dialogue(250, "HELO phpmail");
        return true;

    }

    // stmp   ´.
    function smtp_close() {

        $this->dialogue(221, "QUIT");
        fclose($this->fp);
        return true;

    }

    // ޽ .
    function smtp_send($receiveName, $receiveEmail, $sendName, $sendEmail, $content) {

        if(!$mail_from = $this->get_email($sendEmail)) return false;
        if(!$rcpt_to = $this->get_email($receiveEmail)) return false;

        if(!$this->dialogue(250, "MAIL FROM: $mail_from")) 
            $this->error[] = $receiveEmail.":MAIL FROM ($this->lastmsg)";
        if(!$this->dialogue(250, "RCPT TO: $rcpt_to"))
            $this->error[] = $receiveEmail.":RCPT TO ($this->lastmsg)";
        $this->dialogue(354, "DATA");

        $mime = "Message-ID: <".$this->get_message_id().">\r\n";
        $mime .= "From: $sendName <". $sendEmail. ">\r\n";
        $mime .= "To: $receiveName <". $receiveEmail. ">\r\n";
        //$mime .= "To: $email\r\n";

        fputs($this->fp, $mime);
        fputs($this->fp, $content);
        $this->dialogue(250, ".");

    }

    // Message ID  ´.
  function get_message_id() {
    $id = date("YmdHis",time());
    mt_srand((float) microtime() * 1000000);
    $randval = mt_rand();
    $id .= $randval."@phpmail";
    return $id;
  }

    // Boundary  ´.
  function get_boundary() {
    $uniqchr = uniqid(time());
    $one = strtoupper($uniqchr[0]);
    $two = strtoupper(substr($uniqchr,0,8));
    $three = strtoupper(substr(strrev($uniqchr),0,8));
    return "----=_NextPart_000_000${one}_${two}.${three}";
  }

    // ÷    Լ ̿  ÷Ѵ.
    function attach($message, $name="", $ctype="application/octet-stream") {
        $this->parts[] = array ("ctype" => $ctype, "message" => $message, "name" => $name);
    }

    // Multipart ޽ Ų.
    function build_message($part) {

        $msg .= "Content-Type: ".$part['ctype'];
        if($part['name']) $msg .= "; name=\"".$part['name']."\"";
        $msg .= "\r\nContent-Transfer-Encoding: base64\r\n";
        $msg .= "Content-Disposition: attachment; filename=\"".$part['name']."\"\r\n\r\n";
        $msg .= chunk_split(base64_encode($part['message']));
        return $msg;

    }

    // SMTP  DATA Ų.
    function build_data($receiveId="", $receiveName="", $receiveEmail="", $subject, $content, $htmlType="T", $style="") {

        $boundary = $this->get_boundary();

				if($htmlType == "T") {
					$content = nl2br(htmlspecialchars($content));
				}

				$content = $style.$content;

				$subject = eregi_replace("{NAME}","$receiveName", $subject);
				$subject = eregi_replace("{ID}","$receiveId", $subject);
				$subject = eregi_replace("{EMAIL}","$receiveEmail", $subject);

				$content = eregi_replace("{NAME}","$receiveName", $content);
				$content = eregi_replace("{ID}","$receiveId", $content);
				$content = eregi_replace("{EMAIL}","$receiveEmail", $content);


        $mime .= "Subject: $subject\r\n";
        $mime .= "Date: ".date ("D, j M Y H:i:s T",time())."\r\n";
        $mime .= "MIME-Version: 1.0\r\n";
        $mime .= "Content-Type: multipart/mixed; boundary=\"".$boundary."\"\r\n\r\n".
                 "This is a multi-part message in MIME format.\r\n\r\n";
				$mime .= "--".$boundary."\r\n".
             "Content-Type: ".$this->ctype."; charset=\"".$this->charset."\"\r\n".
             "Content-Transfer-Encoding: base64\r\n\r\n".
             chunk_split(base64_encode($content)).
             "\r\n\r\n--".$boundary;

        $max = count($this->parts);
        for($i=0; $i<$max; $i++) {
            $mime .= "\r\n".$this->build_message($this->parts[$i])."\r\n\r\n--".$boundary;
        }
        $mime .= "--\r\n";

        return $mime;

    }

    // MX  ã´.
    function get_mx_server($email) {
        
        if(!ereg("([\._0-9a-zA-Z-]+)@([0-9a-zA-Z-]+\.[a-zA-Z\.]+)", $email, $reg)) return false;
        getmxrr($reg[2], $host);
        if(!$host) $host[0] = $reg[2];
        return $host;

    }

    // ̸  ´ üũѴ.
    function get_email($email) {
        if(!ereg("([\._0-9a-zA-Z-]+)@([0-9a-zA-Z-]+\.[a-zA-Z\.]+)", $email, $reg)) return false;
        return "<".$reg[0].">";
    }


    //  Ѵ.
    function send($sendName, $sendEmail, $receiveId, $receiveName, $receiveEmail, $subject, $content, $htmlType="T", $style="") {
			
					$content = $this->build_data($receiveId, $receiveName, $receiveEmail, $subject, $content, $htmlType, $style);
					$this->smtp_send($receiveName, $receiveEmail, $sendName, $sendEmail, $content);
					//$this->smtp_close();

    }

}

?>